"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PropTypes = require("prop-types");
var power_di_1 = require("power-di");
var utils_1 = require("power-di/utils");
var event_1 = require("../event");
var utils_2 = require("../utils");
var helper_1 = require("../helper/helper");
var core_1 = require("../core");
var BaseStore_1 = require("../core/BaseStore");
function connect(mapper) {
    return function (target) {
        var _a;
        var storeKeys = [];
        var propsMapper = function propsMapper(state, ownProps, ioc) {
            var mapperProps = {};
            if (mapper) {
                mapperProps = mapper(state, ownProps, ioc) || {};
            }
            var bindData = {};
            var connect = helper_1.getMetadata(target).connect;
            if (connect) {
                for (var key in connect) {
                    var data = bindData[key] = connect[key](ioc);
                    // TODO 支持计算表达式解析store
                    if (storeKeys) {
                        if (data instanceof core_1.BaseStore) {
                            storeKeys.push(BaseStore_1.getStoreMeta(data).adapter.StoreKey);
                        } else {
                            storeKeys = undefined;
                        }
                    }
                }
            }
            return Object.assign({}, ownProps || {}, mapperProps, _defineProperty({}, helper_1.PropsKeySymbol, bindData));
        };
        var Connect = (_a = function (_React$Component) {
            _inherits(_a, _React$Component);

            function _a(props, context) {
                _classCallCheck(this, _a);

                var _this = _possibleConstructorReturn(this, (_a.__proto__ || Object.getPrototypeOf(_a)).call(this, props, context));

                _this.needUpdate = true;
                _this.onStoreChange = function (evt) {
                    _this.checkStateChange();
                };
                _this.ioc = context.iocContext || power_di_1.IocContext.DefaultInstance;
                _this.eventBus = _this.ioc.get(event_1.EventBus);
                _this.odux = _this.ioc.get(core_1.Odux);
                if (!_this.odux) {
                    console.warn("NOTFOUND odux at iocContext (or default instance of ioc), will auto create one with 'new Odux();' on ioc.");
                    _this.odux = new core_1.Odux({ iocContext: _this.ioc });
                }
                var store = _this.odux.getReduxStore();
                _this.state = {
                    data: propsMapper(store && store.getState(), props, _this.ioc)
                };
                return _this;
            }

            _createClass(_a, [{
                key: "componentDidMount",
                value: function componentDidMount() {
                    this.cId = this.eventBus.setComponentListener(undefined, this.onStoreChange, storeKeys);
                }
            }, {
                key: "componentWillUnmount",
                value: function componentWillUnmount() {
                    this.eventBus.setComponentListener(this.cId);
                }
            }, {
                key: "componentWillReceiveProps",
                value: function componentWillReceiveProps(nextProps, nextContext) {
                    this.checkStateChange(nextProps);
                }
            }, {
                key: "shouldComponentUpdate",
                value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
                    return this.needUpdate;
                }
            }, {
                key: "checkStateChange",
                value: function checkStateChange() {
                    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;

                    var store = this.odux.getReduxStore();
                    var newState = propsMapper(store && store.getState(), this.props, this.ioc);
                    this.needUpdate = !utils_2.shallowEqual(this.state.data, newState);
                    if (this.needUpdate) {
                        this.setState({
                            data: newState
                        });
                    }
                    this.needUpdate = this.needUpdate || !utils_2.shallowEqual(this.props, props);
                }
            }, {
                key: "render",
                value: function render() {
                    return React.createElement(target, Object.assign({}, this.props, this.state.data));
                }
            }]);

            return _a;
        }(React.Component), _a.contextTypes = {
            iocContext: PropTypes.any
        }, _a);
        var wrappedComponentName = target.displayName || target.name || utils_1.getGlobalType(target) || 'Component';
        Connect.displayName = "Odux(" + wrappedComponentName + ")";
        return Connect;
    };
}
exports.connect = connect;
//# sourceMappingURL=connect.js.map